/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void CopyCB();
static void PasteCB();
static Widget box, figure, title;
static Pixmap pixmap;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, copy, paste;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Clip2type", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* (1) ȥ٥ϤȢ */
    ac = 0;
    box = XmCreateRowColumn(panel, "box", al, ac);
    XtManageChild(box);
    /*  */
    ac = 0;
    figure = XmCreateLabel(box, "figure", al, ac);
    XtManageChild(figure);
    /* ٥ */
    ac = 0;
    title = XmCreateLabel(box, "title", al, ac);
    XtManageChild(title);

    /* (2) [ԡ] --> åץܡɤ˥ǡ򥳥ԡ */
    ac = 0;
    copy = XmCreatePushButton(panel, "copy", al, ac);
    XtAddCallback(copy, XmNactivateCallback, CopyCB, NULL);
    XtManageChild(copy);

    /* (3) [ڡ] --> åץܡɤǡФ */
    ac = 0;
    paste = XmCreatePushButton(panel, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, NULL);
    XtManageChild(paste);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* (4) [ԡ] ܥΥХå */
static void CopyCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmString label;
    long item_id;
    static int private_id = 0;
    long data_id;
    XmString string;
    char *text;

    /* (5) figure 鳨 (ԥåޥå) Ф */
    XtVaGetValues(figure, XmNlabelPixmap, &pixmap, NULL);

    /* (6) title ٥ʸФ */
    XtVaGetValues(title, XmNlabelString, &string, NULL);
    XmStringGetLtoR(string, XmFONTLIST_DEFAULT_TAG, &text);
    XmStringFree(string);

    /* ԥåޥåפ٥ʸξ󤬼ʤȥ顼 */
    if (pixmap == XmUNSPECIFIED_PIXMAP || text == NULL) {
        XBell(XtDisplay(w), 0);
        return;
    }

    /* Ŭ̾ǥѥɡȥ󥰤äƤ */
    label = XmStringCreateLocalized("_my_data");

    /* (7) åץܡɤؤΥԡ򳫻 */
    if (XmClipboardStartCopy(XtDisplay(box), XtWindow(box), label,
                             XtLastTimestampProcessed(XtDisplay(box)),
                             NULL, NULL, &item_id) != ClipboardSuccess) {
        XBell(XtDisplay(w), 0);
        XmStringFree(label);
        XtFree(text);
        return;
    }
    /* (8) åץܡɤ˥ԥåޥå ID 򥳥ԡ */
    if (XmClipboardCopy(XtDisplay(box), XtWindow(box), item_id,
                        "PIXMAP", &pixmap, sizeof(pixmap), private_id,
                        &data_id) != ClipboardSuccess) {
        XmClipboardCancelCopy(XtDisplay(text), XtWindow(text), item_id);
        XBell(XtDisplay(w), 0);
        XmStringFree(label);
        XtFree(text);
        return;
    }
    /* (9) åץܡɤ˥ȥʸ򥳥ԡ */
    if (XmClipboardCopy(XtDisplay(box), XtWindow(box), item_id,
                        "STRING", text, strlen(text), private_id,
                        &data_id) != ClipboardSuccess) {
        XmClipboardCancelCopy(XtDisplay(text), XtWindow(text), item_id);
        XBell(XtDisplay(w), 0);
        XmStringFree(label);
        XtFree(text);
        return;
    }
    /* (10) åץܡɤؤΥԡλ (ºݤ˥ǡž) */
    if (XmClipboardEndCopy(XtDisplay(box), XtWindow(box), item_id)
                                                         != ClipboardSuccess) {
        XBell(XtDisplay(w), 0);
        XmStringFree(label);
        XtFree(text);
        return;
    }
    private_id++;
    XmStringFree(label);
    XtFree(text);
}

/* (11) [ڡ] ܥΥХå */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    char buff[BUFSIZ];
    unsigned long num_bytes;
    long private_id;
    XmString string;

    /* (12) ǡμФ򳫻 */
    if (XmClipboardStartRetrieve(XtDisplay(box), XtWindow(box),
              XtLastTimestampProcessed(XtDisplay(box))) != ClipboardSuccess) {
        XBell(XtDisplay(w), 0);
        return;
    }

    /* (13) åץܡɤԥåޥå ID Ф */
    if (XmClipboardRetrieve(XtDisplay(box), XtWindow(box),
                         "PIXMAP", &pixmap, sizeof(pixmap), &num_bytes,
                         &private_id) != ClipboardSuccess || num_bytes == 0) {
        XBell(XtDisplay(w), 0);
        return;
    }
    /* (14) Фԥåޥåפ figure ɽ */
    XtVaSetValues(figure, XmNlabelPixmap, pixmap, NULL);

    /* (15) åץܡɤ饿ȥʸФ */
    if (XmClipboardRetrieve(XtDisplay(box), XtWindow(box),
                         "STRING", buff, sizeof(buff), &num_bytes,
                         &private_id) != ClipboardSuccess || num_bytes == 0) {
        XBell(XtDisplay(w), 0);
        return;
    }
    buff[num_bytes] = '\0';  /* Ǹ NULL դ */

    /* (16)Фʸ title ɽ */
    string = XmStringCreateLocalized(buff);
    XtVaSetValues(title, XmNlabelString, string, NULL);
    XmStringFree(string);

    /* (17)ǡμФλ */
    XmClipboardEndRetrieve(XtDisplay(box), XtWindow(box));
}
